import 'package:flutter_test/flutter_test.dart';
import 'package:fst_test/fst_test.dart';

void main() {
  group("EffectLeaf", () {
    testWidgets('calls function on first build', (tester) async {
      int callCount = 0;

      final setState = await tester.pumpStateTree((context, t) {
        final (_, setState) = t.state(() => 0);

        t.effect(() {
          callCount++;
        });

        return setState;
      });

      expect(callCount, equals(1));

      setState(1);
      await tester.pumpStateTree();
      expect(callCount, equals(1));
    });

    testWidgets('calls function when dependency changes', (tester) async {
      int callCount = 0;

      final setState = await tester.pumpStateTree((context, t) {
        final (v, setState) = t.state(() => 0);

        t.effect(() {
          callCount++;
        }, (v,));

        return setState;
      });

      expect(callCount, equals(1));

      setState(1);
      await tester.pumpStateTree();
      expect(callCount, equals(2));

      setState(1);
      await tester.pumpStateTree();
      expect(callCount, equals(2));
    });
  });
}
